import { Host, h } from "@stencil/core";
export class IncldeHelpSpot {
  constructor() {
    this.helpText = '';
  }
  render() {
    return (h(Host, null, h("span", { title: '' }, " ", h("span", { class: "question-mark" }, h("slot", { name: 'hint' }, this.renderDefaultIcon())), h("span", { class: "tooltip" }, this.helpText))));
  }
  renderDefaultIcon() {
    // from https://fontawesome.com/icons/circle-info?f=classic&s=solid
    return h("svg", { xmlns: "http://www.w3.org/2000/svg", height: "1em", viewBox: "0 0 512 512" }, "<!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2023 Fonticons, Inc. -->", h("path", { d: "M256 512A256 256 0 1 0 256 0a256 256 0 1 0 0 512zM216 336h24V272H216c-13.3 0-24-10.7-24-24s10.7-24 24-24h48c13.3 0 24 10.7 24 24v88h8c13.3 0 24 10.7 24 24s-10.7 24-24 24H216c-13.3 0-24-10.7-24-24s10.7-24 24-24zm40-208a32 32 0 1 1 0 64 32 32 0 1 1 0-64z" }));
  }
  static get is() { return "inclde-help-spot"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["inclde-help-spot.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["inclde-help-spot.css"]
    };
  }
  static get properties() {
    return {
      "helpText": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "help-text",
        "reflect": false,
        "defaultValue": "''"
      }
    };
  }
}
//# sourceMappingURL=inclde-help-spot.js.map
