import { Host, h } from "@stencil/core";
import { jsonLdNodeToName, jsonLdNodeToType, jsonLdGetSubNodes, jsonLdGetByID } from "../../utils/utils";
export class IncldeSidebarElement {
  constructor() {
    this.data = undefined;
    this.selector = undefined;
    this.globalSelector = undefined;
    this.expanded = false;
    this.selected = false;
    this.selctedElement = {};
  }
  updateSelectedElement() {
    if (this.selector == undefined) {
      this.selctedElement = {};
      this.selected = false;
      return;
    }
    this.selctedElement = this.data[this.selector];
    this.selected = this.selector == this.globalSelector;
  }
  componentWillLoad() {
    this.updateSelectedElement();
  }
  toggleExpanded(e) {
    this.expanded = !this.expanded;
    e.stopPropagation();
  }
  elementClicked() {
    this.elementSelected.emit({
      selectIndex: this.selector,
    });
  }
  render() {
    const subNodes = jsonLdGetSubNodes(this.data, this.selctedElement);
    return (h(Host, null, h("div", { class: 'sidebar-item' }, h("div", { onClick: () => this.elementClicked(), class: this.selected ? 'sidebar-item-header selected' : 'sidebar-item-header' }, subNodes.size > 0 && h("div", { class: "column button-column" }, h("button", { type: "button", class: "sidebar-expand-button", onClick: (e) => this.toggleExpanded(e) }, this.expanded ? this.renderChildrenIndicatorOpen() : this.renderChildrenIndicatorClosed())), h("div", { class: "column header-column" }, h("span", { class: "sidebar-label" }, jsonLdNodeToName(this.selctedElement)), jsonLdNodeToType(this.selctedElement).map((y) => h("span", { class: "sidebar-type", key: y }, y)))), subNodes.size > 0 && h("div", { class: "sidebar-item-children" }, h("div", { class: this.expanded ? 'sidebar-item-child' : 'sidebar-item-child hidden' }, this.expanded && Array.from(subNodes).map(([path, id]) => {
      return (h("div", null, h("span", { class: "sidebar-propertyname" }, path.split("/").pop(), ":"), h("div", { class: "sidebar-properties" }, id.map((id) => h("inclde-sidebar-element", { data: this.data, selector: jsonLdGetByID(this.data, id), globalSelector: this.globalSelector })))));
    }))))));
  }
  renderChildrenIndicatorOpen() {
    // Font Awesome SVG icon from https://fontawesome.com/icons/caret-down?f=classic&s=solid
    return h("svg", { xmlns: "http://www.w3.org/2000/svg", height: "1em", viewBox: "0 0 320 512" }, "<!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2023 Fonticons, Inc. -->", h("path", { d: "M137.4 374.6c12.5 12.5 32.8 12.5 45.3 0l128-128c9.2-9.2 11.9-22.9 6.9-34.9s-16.6-19.8-29.6-19.8L32 192c-12.9 0-24.6 7.8-29.6 19.8s-2.2 25.7 6.9 34.9l128 128z" }));
  }
  renderChildrenIndicatorClosed() {
    // Font Awesome SVG icon from https://fontawesome.com/icons/caret-right?f=classic&s=solid
    return h("svg", { xmlns: "http://www.w3.org/2000/svg", height: "1em", viewBox: "0 0 256 512" }, "<!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2023 Fonticons, Inc. -->", h("path", { d: "M246.6 278.6c12.5-12.5 12.5-32.8 0-45.3l-128-128c-9.2-9.2-22.9-11.9-34.9-6.9s-19.8 16.6-19.8 29.6l0 256c0 12.9 7.8 24.6 19.8 29.6s25.7 2.2 34.9-6.9l128-128z" }));
  }
  static get is() { return "inclde-sidebar-element"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["inclde-sidebar-element.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["inclde-sidebar-element.css"]
    };
  }
  static get properties() {
    return {
      "data": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "NodeObject[]",
          "resolved": "NodeObject[]",
          "references": {
            "NodeObject": {
              "location": "import",
              "path": "jsonld",
              "id": ""
            }
          }
        },
        "required": true,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "selector": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number | undefined",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "selector",
        "reflect": false
      },
      "globalSelector": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number | undefined",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "global-selector",
        "reflect": false
      }
    };
  }
  static get states() {
    return {
      "expanded": {},
      "selected": {},
      "selctedElement": {}
    };
  }
  static get events() {
    return [{
        "method": "elementSelected",
        "name": "elementSelected",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "SelectEvent",
          "resolved": "{ selectIndex?: number | undefined; selectUrl?: string | undefined; }",
          "references": {
            "SelectEvent": {
              "location": "import",
              "path": "../../utils/events",
              "id": "src/utils/events.ts::SelectEvent"
            }
          }
        }
      }];
  }
  static get watchers() {
    return [{
        "propName": "selector",
        "methodName": "updateSelectedElement"
      }, {
        "propName": "data",
        "methodName": "updateSelectedElement"
      }, {
        "propName": "globalSelector",
        "methodName": "updateSelectedElement"
      }];
  }
}
//# sourceMappingURL=inclde-sidebar-element.js.map
