import { Host, h } from "@stencil/core";
export class IncldeSidebar {
  constructor() {
    this.data = undefined;
    this.selectedIndex = undefined;
    this.rerenderTrigger = false;
  }
  getHTML(data) {
    return (h("div", null, data.map((x, i) => [x, i])
      .filter(([x, _i]) => x['@type'] !== undefined && !x['@id'].startsWith('_:'))
      .map(([_x, i]) => h("inclde-sidebar-element", { data: this.data, selector: i, globalSelector: this.selectedIndex })), h("inclde-add-node-dialogue", { data: this.data })));
  }
  nodeAddedHandler(_event) {
    // trick to trigger re-render
    this.rerenderTrigger = !this.rerenderTrigger;
  }
  render() {
    return (h(Host, null, this.getHTML(this.data)));
  }
  static get is() { return "inclde-sidebar"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["inclde-sidebar.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["inclde-sidebar.css"]
    };
  }
  static get properties() {
    return {
      "data": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "NodeObject[]",
          "resolved": "NodeObject[]",
          "references": {
            "NodeObject": {
              "location": "import",
              "path": "jsonld",
              "id": ""
            }
          }
        },
        "required": true,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "selectedIndex": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number | undefined",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "selected-index",
        "reflect": false
      }
    };
  }
  static get states() {
    return {
      "rerenderTrigger": {}
    };
  }
  static get listeners() {
    return [{
        "name": "nodeAdded",
        "method": "nodeAddedHandler",
        "target": undefined,
        "capture": false,
        "passive": false
      }];
  }
}
//# sourceMappingURL=inclde-sidebar.js.map
