import { Host, h } from "@stencil/core";
import { jsonLdNodeToName } from "../../utils/utils";
export class IncldeViewLink {
  constructor() {
    this.data = [];
    this.selector = undefined;
    this.label = 'Unknown';
  }
  componentWillRender() {
    if (this.selector === undefined) {
      return;
    }
    if (this.data[this.selector]['@id'] !== undefined) {
      this.label = jsonLdNodeToName(this.data[this.selector]);
    }
    else {
      this.label = JSON.stringify(this.data[this.selector]);
    }
  }
  elementClicked() {
    this.elementSelected.emit({
      selectIndex: this.selector,
      selectUrl: this.label,
    });
  }
  render() {
    return (h(Host, null, h("span", { class: this.selector === undefined ? 'view-link view-link-external' : 'view-link', onClick: () => this.elementClicked() }, this.label)));
  }
  static get is() { return "inclde-view-link"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["inclde-view-link.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["inclde-view-link.css"]
    };
  }
  static get properties() {
    return {
      "data": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "NodeObject[]",
          "resolved": "NodeObject[]",
          "references": {
            "NodeObject": {
              "location": "import",
              "path": "jsonld",
              "id": ""
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "defaultValue": "[]"
      },
      "selector": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number | undefined",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "selector",
        "reflect": false
      },
      "label": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "label",
        "reflect": false,
        "defaultValue": "'Unknown'"
      }
    };
  }
  static get events() {
    return [{
        "method": "elementSelected",
        "name": "elementSelected",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "SelectEvent",
          "resolved": "{ selectIndex?: number | undefined; selectUrl?: string | undefined; }",
          "references": {
            "SelectEvent": {
              "location": "import",
              "path": "../../utils/events",
              "id": "src/utils/events.ts::SelectEvent"
            }
          }
        }
      }];
  }
}
//# sourceMappingURL=inclde-view-link.js.map
