import { h } from "@stencil/core";
class BasicEl {
  constructor(value, callback) {
    this.value = "";
    if (typeof value === 'string') {
      this.value = value;
    }
    else if (typeof value === 'number') {
      this.value = value;
    }
    else if (typeof value === 'boolean') {
      this.value = value;
    }
    else {
      console.error('Value type is not supported', value);
    }
    this.callback = callback;
  }
  handleChange(event) {
    if (event.target instanceof HTMLInputElement) {
      if (typeof this.value === 'string') {
        this.value = event.target.value;
      }
      else if (typeof this.value === 'number') {
        this.value = Number(event.target.value);
      }
      else if (typeof this.value === 'boolean') {
        this.value = event.target.checked;
      }
      if (this.callback !== undefined) {
        this.callback(this.value);
      }
    }
  }
  render(editable = true) {
    if (typeof this.value === 'string') {
      return (h("input", { type: "text", value: this.value, onInput: (event) => this.handleChange(event), readOnly: !editable, disabled: !editable }));
    }
    else if (typeof this.value === 'number') {
      return (h("input", { type: "number", value: this.value, onInput: (event) => this.handleChange(event), readOnly: !editable, disabled: !editable }));
    }
    else if (typeof this.value === 'boolean') {
      return (h("input", { type: "checkbox", checked: this.value, onInput: (event) => this.handleChange(event), readOnly: !editable, disabled: !editable }));
    }
    else {
      return (h("span", null, "Value type is not supported"));
    }
  }
}
BasicEl.id = '_direct';
export default BasicEl;
//# sourceMappingURL=basic.js.map
