import BasicEl from "./basic";
import JsonFallbackEl from "./jsonFallback";
import ExternalEl from "./external";
import ValueObjectEl from "./valueObject";
import PropertyValueEl from "./propertyValue";
let customElementList = [ExternalEl, ValueObjectEl, PropertyValueEl];
export function createCustomElement(id, value, callback) {
  if (id === "_direct") {
    return new BasicEl(value, callback);
  }
  for (let customElement of customElementList) {
    if (customElement.id.toLowerCase() === id.toLowerCase() || customElement.id.toLowerCase() === id.replace('http://', 'https://').toLowerCase()) {
      return new customElement(value, callback);
    }
  }
  return new JsonFallbackEl(value, callback);
}
export function getAllCustomElements() {
  return customElementList.map((customElement) => customElement.id);
}
//# sourceMappingURL=index.js.map
