import { h } from "@stencil/core";
class JsonFallbackEl {
  constructor(value, callback) {
    this.value = "";
    this.value = JSON.stringify(value);
    this.callback = callback;
  }
  handleChange(event) {
    if (event.target instanceof HTMLInputElement) {
      this.value = JSON.parse(event.target.value);
      if (this.callback !== undefined) {
        this.callback(this.value);
      }
    }
  }
  render() {
    return (h("input", { type: "text", value: this.value, onInput: (event) => this.handleChange(event) }));
  }
}
JsonFallbackEl.id = '_fallback';
export default JsonFallbackEl;
//# sourceMappingURL=jsonFallback.js.map
