import { h } from "@stencil/core";
import BasicEl from "./basic";
class PropertyValueEl {
  constructor(value, callback) {
    this.name = '';
    let localValue;
    if (value["http://schema.org/value"] !== undefined && value["http://schema.org/value"].length == 1) {
      this.value = value;
      localValue = value["http://schema.org/value"][0]["@value"];
    }
    else {
      console.error("PropertyValue must have a value");
      return;
    }
    if (value["http://schema.org/name"] !== undefined && value["http://schema.org/name"].length == 1) {
      this.name = value["http://schema.org/name"][0]["@value"];
    }
    else {
      console.error("PropertyValue must have a name");
      return;
    }
    let callbackWrapper = (newValue) => {
      value["http://schema.org/value"][0]["@value"] = newValue;
      if (callback !== undefined) {
        callback(value);
      }
    };
    this.basicWrapper = new BasicEl(localValue, callbackWrapper);
  }
  render() {
    if (this.basicWrapper !== undefined) {
      return (h("span", { class: "property-container" }, h("span", { class: "property-name" }, this.name + ":"), h("span", { class: "property-value" }, this.basicWrapper.render())));
    }
    else {
      return (h("span", null, "This Property Value is not supported"));
    }
  }
}
PropertyValueEl.id = 'http://schema.org/PropertyValue';
export default PropertyValueEl;
//# sourceMappingURL=propertyValue.js.map
