import { h } from "@stencil/core";
import BasicEl from "./basic";
class ValueobjectEl {
  constructor(value, callback) {
    if (value["@value"] !== undefined) {
      let callbackWrapper = (newValue) => {
        value["@value"] = newValue;
        if (callback !== undefined) {
          callback(value);
        }
      };
      this.basicWrapper = new BasicEl(value["@value"], callbackWrapper);
    }
    else {
      console.error('Not a Value Object', value);
    }
  }
  render() {
    if (this.basicWrapper !== undefined) {
      return this.basicWrapper.render();
    }
    else {
      return (h("span", null, "Not a Value Object"));
    }
  }
}
ValueobjectEl.id = '@value';
export default ValueobjectEl;
//# sourceMappingURL=valueObject.js.map
