import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { d as defineCustomElement$3 } from './inclde-add-node-dialogue2.js';
import { d as defineCustomElement$2 } from './inclde-help-spot2.js';
import { d as defineCustomElement$1 } from './inclde-sidebar-element2.js';

const incldeSidebarCss = ":host{display:block}.subel{padding-left:15px;border:1px solid #999999}";

const IncldeSidebar = /*@__PURE__*/ proxyCustomElement(class IncldeSidebar extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.data = undefined;
    this.selectedIndex = undefined;
    this.rerenderTrigger = false;
  }
  getHTML(data) {
    return (h("div", null, data.map((x, i) => [x, i])
      .filter(([x, _i]) => x['@type'] !== undefined && !x['@id'].startsWith('_:'))
      .map(([_x, i]) => h("inclde-sidebar-element", { data: this.data, selector: i, globalSelector: this.selectedIndex })), h("inclde-add-node-dialogue", { data: this.data })));
  }
  nodeAddedHandler(_event) {
    // trick to trigger re-render
    this.rerenderTrigger = !this.rerenderTrigger;
  }
  render() {
    return (h(Host, null, this.getHTML(this.data)));
  }
  static get style() { return incldeSidebarCss; }
}, [1, "inclde-sidebar", {
    "data": [16],
    "selectedIndex": [2, "selected-index"],
    "rerenderTrigger": [32]
  }, [[0, "nodeAdded", "nodeAddedHandler"]]]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["inclde-sidebar", "inclde-add-node-dialogue", "inclde-help-spot", "inclde-sidebar-element"];
  components.forEach(tagName => { switch (tagName) {
    case "inclde-sidebar":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, IncldeSidebar);
      }
      break;
    case "inclde-add-node-dialogue":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "inclde-help-spot":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "inclde-sidebar-element":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { IncldeSidebar as I, defineCustomElement as d };

//# sourceMappingURL=inclde-sidebar2.js.map