import { r as registerInstance, h, H as Host } from './index-30b93e82.js';

const incldeHelpSpotCss = ":host{display:inline-block;vertical-align:middle}:host+span{height:100%}.question-mark{cursor:help;fill:#aaa;display:flex;align-items:center;justify-content:center;height:100%}svg{width:1em;height:1em;vertical-align:baseline}.tooltip{display:none;position:absolute;background-color:#333;color:#fff;padding:5px 10px;border-radius:5px;margin:0.3em;z-index:1}.question-mark:hover+.tooltip{display:inline-block}";

const IncldeHelpSpot = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.helpText = '';
  }
  render() {
    return (h(Host, null, h("span", { title: '' }, " ", h("span", { class: "question-mark" }, h("slot", { name: 'hint' }, this.renderDefaultIcon())), h("span", { class: "tooltip" }, this.helpText))));
  }
  renderDefaultIcon() {
    // from https://fontawesome.com/icons/circle-info?f=classic&s=solid
    return h("svg", { xmlns: "http://www.w3.org/2000/svg", height: "1em", viewBox: "0 0 512 512" }, "<!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2023 Fonticons, Inc. -->", h("path", { d: "M256 512A256 256 0 1 0 256 0a256 256 0 1 0 0 512zM216 336h24V272H216c-13.3 0-24-10.7-24-24s10.7-24 24-24h48c13.3 0 24 10.7 24 24v88h8c13.3 0 24 10.7 24 24s-10.7 24-24 24H216c-13.3 0-24-10.7-24-24s10.7-24 24-24zm40-208a32 32 0 1 1 0 64 32 32 0 1 1 0-64z" }));
  }
};
IncldeHelpSpot.style = incldeHelpSpotCss;

export { IncldeHelpSpot as inclde_help_spot };

//# sourceMappingURL=inclde-help-spot.entry.js.map