import { EventEmitter } from '../../stencil-public-runtime';
import { NodeObject } from 'jsonld';
import { SelectEvent } from '../../utils/events';
export declare class IncldeEditor {
  data: object | string;
  config: object | string;
  dataObject: NodeObject[];
  selectedIndex?: number;
  /**
   * Fired when the editor is closed with the save or cancel buttons.
   * `event.detail` contains the edited data if the save button was clicked, undefined otherwise.
   */
  editorClosed: EventEmitter<NodeObject | NodeObject[] | undefined>;
  /**
   * Fired when the data is updated. Can be used to peek into the data from outside the editor.
   * Not yet reliably fired.
   * Returns the same information as the `editorClosed` event.
   */
  dataUpdated: EventEmitter<NodeObject | NodeObject[] | string>;
  private configHelper;
  componentWillLoad(): Promise<void>;
  selectionHandler(event: CustomEvent<SelectEvent>): void;
  redrawHandler(): void;
  private closeEditor;
  render(): any;
}
