import { EventEmitter } from '../../stencil-public-runtime';
import { NodeObject } from 'jsonld';
/**
 * This component represents the properties of a selected entity.
 */
export declare class IncldeView {
  data: NodeObject[];
  /**
   * The index of the object to render.
   */
  selectedIndex?: number;
  redraw: EventEmitter<CustomEvent>;
  private config;
  private deleteElement;
  private renderHTML;
  /**
   * Renders html to enable the user to add further attributes to the selected object.
   *
   * @param selectedIndex the index of the selected object of this view.
   * @returns the html
   */
  private renderAddAttributeButton;
  /**
   * Returns a delete button for elements which do not have any other possible action.
   *
   * @param key the key to delete
   * @returns the html
   */
  private renderPredicateActionButtons;
  /**
   * Adds buttons for moving up and down or deleting an object.
   *
   * @param index current index of the object
   * @param key the key/name of the object
   * @param value the object
   * @returns the html to render
   */
  private renderPropertyActionButtons;
  private renderDeleteIcon;
  render(): any;
}
