export declare class SchemaDotOrg {
  private static instance;
  private constructor();
  static getInstance(): SchemaDotOrg;
  private schemaPromise;
  private schema;
  private propertyMap;
  loadSchemaDefinition(url: string): void;
  awaitSchemaDefinition(): Promise<void>;
  /**
   * Returns a list of all classes in the schema.
   * These are the types for the objects expected in the sidebar.
   * @returns A list of all classes in the schema
   */
  getAllClasses(): string[];
  private getById;
  private appendToPropertyMap;
  getPropertiesByType(id: string): string[] | undefined;
  getDataTypesByProperty(id: string): string[] | undefined;
}
